// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk f_box_00.pov +w1200 +h900  (quick and ugly)
//     yuqk f_box_00.pov +w1200 +h900 +a0.05 +am2 +r3 +j3.33 +d +p
// Note. To 'see' the linear values add 'display_gamma=1.0' to command line
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3,3,-3.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare VarOrthoMult =
    2.0/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare Camera01y = camera {
    orthographic
    location <0,2,0>
    direction -y
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*z*max(1,image_height/image_width)
}
#declare Camera01x = camera {
    orthographic
    location <2,0,0>
    direction -x
    right VarOrthoMult*z*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare CylinderX = cylinder { -2*x, 2*x, 0.01 }
#declare CylinderY = cylinder { -2*y, 2*y, 0.01 }
#declare CylinderZ = cylinder { -2*z, 2*z, 0.01 }
#include "functions.inc"
// Function f_box defined in functions.inc
#declare Fn00p = function (x,y,z) { f_box(x,y,z,0,0.5,0.5,0.5) }
#declare Iso = isosurface {
    function { f_box(x,y,z,0,0.5,0.5,0.5) }
    contained_by { box { <-1,-1,0>,<1,1,1> } }
    threshold 0
    accuracy 0.0005
    max_gradient 2.8
}
#declare Red = srgb <1,0,0>;
#declare BallBlue = srgb <0.12941,0.67059,0.80392>;
#declare Banjul = srgb <0.08235,0.04706,0.03137>;
#declare Beer = srgb <0.94902,0.55686,0.1098>;
#declare Green = srgb <0,1,0>;
#declare ColorMap = color_map {
    [ -10 Red ]
    [  -1 BallBlue ]
    [   0 Banjul ]
    [   1 Beer ]
    [  10 Green ]
}
#declare Pig_f_box = pigment {
    function { Fn00p(x,y,z) }
    raw_wave
    color_map { ColorMap }
}
#declare Txtr = texture { pigment { Pig_f_box } }
#declare Obj = object { Iso texture { Txtr } }
#declare Union00 = union {
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
}
#declare TxtrAxes = texture { pigment { Pig_f_box } }
#declare ObjAxes = object { Union00 texture { TxtrAxes } }

//--- scene ---
    camera { Camera00 }
    light_source { Light00 }
//  camera { Camera01x }
//  camera { Camera01y }
//  camera { Camera01z }
    object { Obj }
    object { ObjAxes }
