// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk fade_power_01.pov +w1200 +h900  (quick and ugly)
//     yuqk fade_power_01.pov +w1200 +h900 +a0.05 +am2 +r3 +j5.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings {
    assumed_gamma 1
    max_trace_level 7
    shadow_tolerance 1e-05
}
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3.1,3.1,-3.101>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare Plane00 = plane { y, -0.1 pigment { White } }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -2*x, 2*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -2*y, 2*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -2*z, 2*z, 0.01 pigment { Blue } }
#declare Sphere01 = sphere { 0, 0.5 }
#declare Plane01 = plane { y, -0.1+2e-5 }
#declare Dome01 = difference {
    object { Sphere01 }
    object { Plane01 }
}
#declare ClearBlack100 = srgbt <0,0,0,1>;
#declare Pigm00 = pigment { ClearBlack100 }
#declare Fin00 = finish { phong 0.7 phong_size 500 }
#declare Fin01 = finish { diffuse 0 }
#declare Texture00 = texture { pigment { Pigm00 } finish { Fin00 } }
#declare Texture01 = texture { pigment { Pigm00 } finish { Fin01 } }
#declare Eternity = srgb <0.12941,0.10196,0.0549>;
// Set fade_power to -0.5 for effect. (Using std::pow(<channel value>,2.0)
#declare Interior00 = interior {
    ior 1
    fade_distance 0.3
    fade_power -e
    fade_color Eternity
}
// Set fade_power to std::exp() with values >=1000
#declare Interior01 = interior {
    ior 1
    fade_distance 0.3
    fade_power 1000
    fade_color Eternity
}
#declare Material00 = material {
    texture { Texture00 }
    interior_texture { Texture01 }
    interior { Interior00 }
}
#declare Material01 = material {
    texture { Texture00 }
    interior_texture { Texture01 }
    interior { Interior01 }
}
// Yes. The left, exp() mode falls off faster initially than the pow() mode
#declare Obj01 = object {
    Dome01
    material { Material00 }
    translate <+0.65,0,+0.65>
}
#declare Obj02 = object {
    Dome01
    material { Material01 }
    translate <-0.65,0,-0.65>
}

//--- scene ---
    camera { Camera00 }
    light_source { Light00 }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    object { Obj01 }
    object { Obj02 }
    object { Plane00 }
