// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk seedfi_00.pov +w1200 +h900  (quick and ugly)
//     yuqk seedfi_00.pov +w1200 +h900 +a0.0 +am2 +r4 +j13.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare VarOrthoMult =
    2.0/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare CarmineRed = srgb <1,0,0.21961>;
#declare Black = srgb <0,0,0>;
#declare ChalkGreen = srgb <0.11765,0.68627,0.07843>;
#declare ColorMap = color_map {
    [ -1 CarmineRed ]
    [  0 Black ]
    [  1 ChalkGreen ]
}
// The focus is just below. It shows the use of the seedfi pattern and that it
// needs to use function_interval due the -1..1 values it generates. There is
// too a chaining of two _wave general value pattern modifiers which can
// create effects not otherwise easily achieved.
#declare Fn = function {
    pattern {
        seedfi function_interval sine_wave
        warp { turbulence <0,0,1.667> octaves 5 omega 0.67 lambda 5.3 it_scale 1/7 }
    }
}
#declare Pigment00 = pigment {
    function { Fn(x,y,z) }
    function_interval
    frequency 33 triangle_wave
    color_map { ColorMap }
    translate <0,0,-0.5> scale 1/3
}
#declare Finish00 = finish { emission rgb <1,1,1> }
#declare Texture00 = texture {
    pigment { Pigment00 }
    finish { Finish00 }
}
#declare Plane00 = plane { z, 0 }
#declare Object00 = object { Plane00 texture { Texture00 } }

//--- scene ---
    camera { Camera01z }
    object { Object00 }
