// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk soft_object_01.pov +w1200 +h900  (quick and ugly)
//     yuqk soft_object_01.pov +w1200 +h900 +a0.05 +am2 +r3 +j5.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare VarOrthoMult =
    2.0/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare Plane00 = plane { -z, 0 }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -1*x, 1*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -1*y, 1*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -1*z, 1*z, 0.01 pigment { Blue } }
#declare TextR = text {
    ttf "timrom.ttf" "R"
    0.2, 0
    translate <-0.0,-0.0,-0.1>
}
#declare VarSpacing = 0.025;
#declare VarStrength = 1.00;
#declare FnSoft00 = function {
    pattern {
        soft_object {
            TextR
            spacing  VarSpacing
            strength VarStrength
        }
        function_interval
    }
}
#declare Black = srgb <0,0,0>;
#declare ColorMap = color_map {
    [ -3 Red ]
    [  0 Black ]
    [  3 Green ]
}
#declare PigSoft = pigment {
    function { FnSoft00(x,y,z) }
    function_interval
    color_map { ColorMap }
}
#declare FinSoft = finish { emission rgb <1,1,1> }
#declare TxtrSoft = texture {
    pigment { PigSoft }
    finish { FinSoft }
}
#declare ObjectSoft = object { Plane00 texture { TxtrSoft } }

//--- scene ---
    camera { Camera01z }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    object { ObjectSoft }
